<id>
vDirectNotify Mod
</id>

<version>
0.91
</version>

<mod info>
Adds direct notification functionality.
</mod info>

<author>
Valodim
</author>

<homepage>
mugenguild.com
</homepage>



<edit file>
$sourcedir/Load.php
</edit file>


<search for>
			mem.totalTimeLoggedIn, mem.ID_POST_GROUP, mem.notifyAnnouncements, mem.notifyOnce, mem.notifySendBody,
</search for>

<replace>
			mem.totalTimeLoggedIn, mem.ID_POST_GROUP, mem.notifyAnnouncements, mem.notifyOnce, mem.notifySendBody, mem.notifyAddress, mem.notifyPort, mem.notifyPassword,
</replace>



<edit file>
$sourcedir/Profile.php
</edit file>


<search for>
		'notify_types' => $user_profile[$memID]['notifyTypes'],
</search for>

<add after>
		'notify_address' => $user_profile[$memID]['notifyAddress'],
		'notify_port' => $user_profile[$memID]['notifyPort'],
		'notify_password' => $user_profile[$memID]['notifyPassword'],
</add after>


<search for>
	// How many rows can we expect?
</search for>

<add before>
	$context['can_direct_notify'] = allowedTo('vnotify_direct');

</add before>


<search for>
		'ID_THEME',
</search for>

<add after>
		'notifyPort',
</add after>


<search for>
		'signature', 'personalText', 'avatar',
</search for>

<add after>
		'notifyAddress', 'notifyPassword',
</add after>


<search for>
			$_POST['smileySet'] = '';
	}
</search for>

<add after>

	// validate notification address
	if (isset($_POST['notifyAddress']))
	{
		if(!allowedTo('vnotify_direct') || $_POST['notifyAddress'] == 'mail' || strlen($_POST['notifyAddress']) > 200)
			$_POST['notifyAddress'] = 'mail';
		// if it's mail or lastip, just skip this. if not, validate
		elseif ($_POST['notifyAddress'] == 'accountip' || $_POST['notifyAddress'] == 'ip')
			$_POST['notifyAddress'] = 'accountip';
		// current ip, checks already done by load routines ;)
		elseif($_POST['notifyAddress'] == 'currentip')
			$_POST['notifyAddress'] = $_SERVER['REMOTE_ADDR'];
		// is it a valid IP?
		elseif(preg_match('/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/', $_POST['notifyAddress']) != 1)
			// no? maybe a hostname?
			if($_POST['notifyAddress'] == gethostbyname($_POST['notifyAddress']))
				// doesn't look valid. kill :P
				$_POST['notifyAddress'] = 'mail';

		// make sure this is a valid port (just set to default if it's not)
		if(empty($_POST['notifyPort']) || !is_numeric($_POST['notifyPort']) || $_POST['notifyPort'] > 65535 || $_POST['notifyPort'] < 0)
			$_POST['notifyPort'] = 12001;
		// validate this
		if(empty($_POST['notifyPassword']))
			$_POST['notifyPassword'] = '';
		elseif(strlen($_POST['notifyPassword']) > 100)
			$_POST['notifyPassword'] = substr($_POST['notifyPassword'], 0, 100);
	}
</add after>



<edit file>
$themedir/Profile.template.php
</edit file>


<search for>
								<option value="4"', $context['member']['notify_types'] == 4 ? ' selected="selected"' : '', '>', $txt['notify_send_type_nothing'], '</option>
							</select><br />
</search for>

<replace>
								<option value="4"', $context['member']['notify_types'] == 4 ? ' selected="selected"' : '', '>', $txt['notify_send_type_nothing'], '</option>
							</select><br />';

	if (empty($modSettings['vnotify_disable']) && !empty($context['can_direct_notify']))
		echo '
							<table align="center">
                                                        	<tr>
									<td><label for="notifyAddress">', $txt['notify_address'], '</label></td>
									<td><input type="text" id="notifyAddress" name="notifyAddress" maxlength="200" value="', $context['member']['notify_address'], '" /> <a href="', $scripturl, '?action=helpadmin;help=direct_notify" onclick="return reqWin(this.href);" class="help"><img src="', $settings['images_url'], '/helptopics.gif" alt="', $txt['notify_address'], '" border="0" /></a></td>
								</tr>
								<tr>
									<td><label for="notifyPort">', $txt['notify_port'], '</label></td>
									<td><input type="text" id="notifyPort" name="notifyPort" maxlength="5" value="', $context['member']['notify_port'], '" /></td>
								</tr>
                                                                <tr>
                                                                	<td><label for="notifyPassword">', $txt['notify_password'], '</label></td>
                                                                        <td><input type="text" id="notifyPassword" name="notifyPassword" maxlength="100" value="', $context['member']['notify_password'], '" /></td>
								</tr>
							</table>';

	echo '
</replace>



<edit file>
$sourcedir/Subs-Post.php
</edit file>


<search for>
			mem.ID_MEMBER, mem.emailAddress, mem.notifyOnce, mem.notifyTypes, mem.notifySendBody, mem.lngfile,
</search for>

<replace>
			mem.ID_MEMBER, mem.emailAddress, mem.notifyOnce, mem.notifyTypes, mem.notifySendBody, mem.notifyAddress, mem.notifyPort, mem.notifyPassword, mem.memberIP, mem.lngfile,
</replace>


<search for>
			$message .= "\n\n" . $txt['notifyXOnce2'];
</search for>

<add after>

		$directmessage = sprintf($txt['direct_' . $current_type['message']], un_htmlspecialchars($user_info['name']));
		// do they want the body of the message sent too?
		if (!empty($row['notifySendBody']) && $type == 'reply' && empty($modSettings['disallow_sendBody']))
			$directmessage .= "\n\n\n" . $body;
</add after>


<search for>
			sendmail($row['emailAddress'], sprintf($txt[$current_type['subject']], $subject),
				$message . "\n\n" .
				$txt[130], null, 'm' . $last_id);
</search for>

<replace>
			if($row['notifyAddress'] == 'mail' || !empty($modSettings['vnotify_disable']))
				sendmail($row['emailAddress'], sprintf($txt[$current_type['subject']], $subject),
					$message . "\n\n" .
					$txt[130], null, 'm' . $last_id);
			// that means we send the notify to the specified address
			elseif(!empty($row['notifyAddress']) && !empty($row['notifyPort'])) {
				// current ip?
				if($row['notifyAddress'] == 'accountip')
					$address = $row['memberIP'];
				// is it a (valid) ip?
				elseif(preg_match('/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/', $row['notifyAddress']) == 1)
					$address = $row['notifyAddress'];
				// is it a hostname?
				elseif($row['notifyAddress'] != gethostbyname($row['notifyAddress']))
					$address = gethostbyname($row['notifyAddress']);
				// no? well, just continue. we can't bother the user with this error message >_>
				else
					continue;

				$socket = fsockopen("udp://" . $address, $row['notifyPort'], $errno, $errstr, empty($modSettings['vnotify_timeout']) ? 0.5 : $modSettings['vnotify_timeout']);
				if($socket) {
					fputs($socket, '%' . (!empty($row['notifyPassword']) ? '#passwd:' . $row['notifyPassword'] : '') . '#delay:20#left:open:' . $scripturl . '?topic=' . $ID_TOPIC . '.new;close#from:' . sprintf($txt['direct_' . $current_type['subject']], $subject) . '#msg:' . $directmessage);
					fclose($socket);
				}

				// we don't handle errors, not every pc is online 24/7 >_>
			}
</replace>



<edit file>
$sourcedir/ManagePermissions.php
</edit file>


<search for>
				'profile_remote_avatar' => false,
			)
</search for>

<replace>
				'profile_remote_avatar' => false,
			),
			'vnotify' => array(
				'vnotify_direct' => false,
			),
</replace>



<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
			array('check', 'queryless_urls'),
</search for>

<add after>
			array('check', 'vnotify_disable'),
			array('float', 'vnotify_timeout'),
</add after>



<edit file>
$themedir/languages/Modifications.english.php
</edit file>


<search for>
// Version: 1.1 RC2; Modifications
</search for>

<add after>
$txt['permissiongroup_vnotify'] = 'Direct Notification';
$txt['permissionname_vnotify_direct'] = 'Get direct notification';
$txt['permissionhelp_vnotify_direct'] = 'Allows the user to specify a direct notification destination. Be careful, the settings are not reset if you clear this permission!!';

$txt['notify_address'] = 'Notification Address';
$txt['notify_port'] = 'Port';
$txt['notify_password'] = 'Password';

// modSettings
$txt['vnotify_disable'] = 'Disable direct notifications';
$txt['vnotify_timeout'] = 'Direct notification timeout';

// use numeric entities in the below sixteen strings.
$txt['direct_notification_reply_subject'] = 'Topic reply: %s';
$txt['direct_notification_reply'] = 'Reply by %s.' . "\n\n";
$txt['direct_notification_sticky_subject'] = 'Topic stickied: %s';
$txt['direct_notification_sticky'] = 'A topic you are watching has been marked as a sticky topic by %s.';
$txt['direct_notification_lock_subject'] = 'Topic locked: %s';
$txt['direct_notification_lock'] = 'A topic you are watching has been locked by %s.';
$txt['direct_notification_unlock_subject'] = 'Topic unlocked: %s';
$txt['direct_notification_unlock'] = 'A topic you are watching has been unlocked by %s.';
$txt['direct_notification_remove_subject'] = 'Topic removed: %s';
$txt['direct_notification_remove'] = 'A topic you are watching has been removed by %s.';
$txt['direct_notification_move_subject'] = 'Topic moved: %s';
$txt['direct_notification_move'] = 'A topic you are watching has been moved to another board by %s.';
$txt['direct_notification_merge_subject'] = 'Topic merged: %s';
$txt['direct_notification_merge'] = 'A topic you are watching has been merged with another topic by %s.';
$txt['direct_notification_split_subject'] = 'Topic split: %s';
$txt['direct_notification_split'] = 'A topic you are watching has been split into two or more topics by %s.';
</add after>



<edit file>
$themedir/languages/Help.english.php
</edit file>


<search for>
$txt[1006] = 'Close window';
</search for>

<add after>
$helptxt['vnotify_disable'] = 'Check this to disable the direct notification mod entirely';
$helptxt['vnotify_timeout'] = 'The number of seconds for the direct connection to time out. Settings this too low may interrupt the transfer, setting it too high may result in long wait times.<br /><br />Default is 0.5';
$helptxt['direct_notify'] = 'In this field, you may specify an address the direct notifications are sent to.<br />You may use "accountip" to use the account\'s ip, "currentip" to use your current ip, or "mail" to just receive the notifies by mail.<br /><br />For further information, read <a href="http://mugenguild.com/stuff/vDirectNotify.htm" target="_blank">here</a>.';
</add after>